<?php
/**
* Joomla Community Builder User Plugin: plug_mutualconns
* @version $Id$
* @package plug_mutualconns
* @subpackage cmutualconns.php
* @author Curtis Kayfish (ckayfish)
* @copyright (C) 2009-2009 Curtis Kayfish
* @license Limited http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
* @final 1.2  (compatible with CB 1.2.x)
*/

/** ensure this file is being included by a parent file */
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

class getmutualconnsTab extends cbTabHandler {

	function getmutualconnsTab() {
		$this->cbTabHandler();
	}

	function getDisplayTab($tab, $user, $ui) {
		global $_CB_framework, $_CB_database;
		//Set required parameters
		$profileownerid = $user->id;
		$myownid = $_CB_framework->myId();
		$params = $this->params;
		$showtext = $params->get('mcShowtext', 1);

		$html = null;

		if  ( $params->get('mcPlugEnabled',1) && $myownid && ($profileownerid != $myownid)) {
			// Get remaining parameters
			$myuname         = $_CB_framework->myusername();
			$profileusername = $user->username;
			$showintro       = $params->get('mcShowintro', 1);
			$introtext       = $params->get('mcIntrotext', "Hi");
			$nomutualstext   = $params->get('mcMessage0', "you do not have any mutual connections with");
			$onemutualtext   = $params->get('mcMessage1', "you only have one connection in common with");
			$mutualbeftext   = $params->get('mcMessagebef', "you have");
			$mutualafttext   = $params->get('mcMessageaft', "connections in common with");
			$numtoshow       = $params->get('mcNumtoshow', 100);
			$displayType     = $params->get('mcDisplayType', 0);
			$livesite        = $_CB_framework->getCfg( 'live_site' );
			$picmargin       = $params->get('mcPicmargin', 5);
			// Select mutual Friends
			$query = "SELECT m.*,u.name,u.username,c.avatar,c.avatarapproved, u.id "
			. "\n FROM #__comprofiler_members AS m"
			. "\n LEFT JOIN #__comprofiler AS c ON m.memberid=c.id"
			. "\n LEFT JOIN #__users AS u ON m.memberid=u.id"
			. "\n WHERE m.referenceid=".$profileownerid
			. "\n AND c.approved=1 AND c.confirmed=1 AND c.banned=0 AND u.block=0"
			. "\n AND m.memberid IN"
			."(SELECT memberid"
				. "\n FROM #__comprofiler_members AS m"
				. "\n LEFT JOIN #__comprofiler AS c ON m.memberid=c.id"
				. "\n LEFT JOIN #__users AS u ON m.memberid=u.id"
				. "\n WHERE m.referenceid=".$myownid
				. "\n AND c.approved=1 AND c.confirmed=1 AND c.banned=0 AND u.block=0)"
				. "\n ORDER BY m.membersince DESC, m.memberid ASC";
				$_CB_database->setQuery($query);
				$mutuals = $_CB_database->loadObjectList();
				$mutualCount = count($mutuals);

				if ($showtext) {
					if ($showintro) {
						$html.= $introtext." ".$myuname.", ";
						}
					if ($mutualCount < 1) {
						$html.= $nomutualstext;
						} elseif ($mutualCount < 2) {
						$html.= $onemutualtext;
						} else {
							$html.= $mutualbeftext." ".$mutualCount." ".$mutualafttext;
						}
					if ($params->get('mcShowuname', 1)) {
						$html.= " ".$profileusername.".";
						}
					$html.="<br /><br />";
				}

				$j=1; //Used to count number of records displayed to ensure $numtoshow is not exceeded
				if ($displayType < 1) { //If display type is username
					$html.="<strong>";
					foreach ($mutuals as $mutual) {
						if ($j <= $numtoshow ) { //Only show max number to show
							$html.= "<a href='".$_CB_framework->userProfileUrl($mutual->id)."'>".$mutual->username."</a>";
							if (($j < $mutualCount) && ($j < $numtoshow)) { //Add comma after all except last entry
								$html.= ", ";
							}
							$j+=1;
						}
					}
					$html.="</strong>";
				} else { //If display type avatar
					foreach ($mutuals as $mutual) {
							if ($j <= $numtoshow ) { //Only show max number to show
								$html.= "<a href='".$_CB_framework->userProfileUrl($mutual->id)."'><img style='float:left; margin-right: ".$picmargin."px; margin-bottom: ".$picmargin."px;'src='".$livesite."/images/comprofiler/tn".$mutual->avatar."' /></a>";
							}
						$j+=1;
					}
					$html.=	"<div style='clear:both;'></div>";
				} //Endif $displaytype

		} //End if enabled & not guest & not own profile
		return $html;
	} //End function

}  //End Class